Zudoku
Unikraft Cloud Platform API

Certificates

Server

Unikraft Cloud allows you to host your deployment at subdomains of the intended metro and/or use custom domains (e.g., example.com). Typically, Unikraft Cloud will automatically generate a TLS certificate for you based on Let's Encrypt™ via a DNS-01 challenge.

For subdomains, your deployment will use the wildcard TLS certificate of the respective Unikraft Cloud metro.

For wildcard domains you have to supply your own certificate. If you want to use Let's Encrypt™ you can use their DNS-based challenge and upload the resulting certificate to Unikraft Cloud.


List Certificates

GET
https://api.sfo.unikraft.cloud
/v1/certificates

List certificates.

List Certificates › query Parameters

uuid
​string[]

The UUID of the resource.

name
​string[]

The name of the resource.

details
​boolean
count
​integer · uint32
from
​string
order
​Common.PaginationOrder · enum

The sort order used by list endpoints.

Enum values:
asc
desc
sortby
​Common.PaginationSortBy · enum

The sort field used by list endpoints.

Enum values:
create_time

List Certificates › Request Body optional

An identifier for a resource — either a name or a UUID, but not both.
uuid
​string · uuid

The UUID of the resource.

name
​string

The name of the resource.

oneOf
Exactly one variant must match.

Decision Table

VariantMatching Criteria
type = object · requires: uuid
type = object · requires: name
Properties for Variant 1:
uuid
​string · uuid · required

The UUID of the resource.

name
​string

The name of the resource.

List Certificates › Responses

200

The request has succeeded.

The response message for getting one or more certificate(s) given their UUID(s) or name(s).
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.


Update Certificates

PUT
https://api.sfo.unikraft.cloud
/v1/certificates

Update certificates.

Update Certificates › Request Body

A single update operation to be applied to a certificate.
chain
​string · required

The new certificate chain. This is the public chain of the certificate in PEM format. The chain should include the certificate and any intermediate certificates.

pkey
​string · required

The new private key. This is the private key of the certificate in PEM format. The private key must match the public key in the certificate chain.

uuid
​string · uuid

The UUID of the resource.

name
​string

The name of the resource.

Update Certificates › Responses

200

The request has succeeded.

The response message for updating one or more certificate(s) given their UUID(s) or name(s).
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.


Create Certificate

POST
https://api.sfo.unikraft.cloud
/v1/certificates

Upload a new certificate.

Create Certificate › Request Body

The request message for creating/uploading a new certificate.
chain
​string · required

The certificate chain in PEM format. Required for user-uploaded certificates.

pkey
​string · required

The private key in PEM format. Required for user-uploaded certificates.

name
​string

The name of the resource. If not provided, a random name is generated. The name must be unique within the context of your account.

node
​string

The name of the node to place the resource on. If not provided, the platform picks one. Only accepted on metros that span multiple nodes.

common_name
​string

The common name (CN) of the certificate.

This must be a fully-qualified domain name (FQDN). Exactly one of cn or common_name must be specified.

Example: funky-town.com

Create Certificate › Responses

200

The request has succeeded.

The response message for creating a new certificate.
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.


Delete Certificates

DELETE
https://api.sfo.unikraft.cloud
/v1/certificates

Delete certificates by ID(s).

Delete Certificates › Request Body

An identifier for a resource — either a name or a UUID, but not both.
uuid
​string · uuid

The UUID of the resource.

name
​string

The name of the resource.

oneOf
Exactly one variant must match.

Decision Table

VariantMatching Criteria
type = object · requires: uuid
type = object · requires: name
Properties for Variant 1:
uuid
​string · uuid · required

The UUID of the resource.

name
​string

The name of the resource.

Delete Certificates › Responses

200

The request has succeeded.

The response message for deleting of one or more certificate(s) given their UUID(s) or name(s).
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.


Get Certificate by UUID

GET
https://api.sfo.unikraft.cloud
/v1/certificates/{uuid}

Get a certificate by UUID.

Get Certificate by UUID › path Parameters

uuid
​string · uuid · required

Get Certificate by UUID › Responses

200

The request has succeeded.

The response message for getting one or more certificate(s) given their UUID(s) or name(s).
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.


Update Certificate by UUID

PUT
https://api.sfo.unikraft.cloud
/v1/certificates/{uuid}

Update a certificate by UUID.

Update Certificate by UUID › path Parameters

uuid
​string · uuid · required

Update Certificate by UUID › Request Body

The request body for updating a certificate by its UUID or name.
chain
​string · required

The new certificate chain. This is the public chain of the certificate in PEM format. The chain should include the certificate and any intermediate certificates.

pkey
​string · required

The new private key. This is the private key of the certificate in PEM format. The private key must match the public key in the certificate chain.

Update Certificate by UUID › Responses

200

The request has succeeded.

The response message for updating one or more certificate(s) given their UUID(s) or name(s).
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.


Delete Certificate by UUID

DELETE
https://api.sfo.unikraft.cloud
/v1/certificates/{uuid}

Delete a certificate by UUID.

Delete Certificate by UUID › path Parameters

uuid
​string · uuid · required

Delete Certificate by UUID › Responses

200

The request has succeeded.

The response message for deleting of one or more certificate(s) given their UUID(s) or name(s).
status
​string · enum · required

The status of the response.

Enum values:
success
error
partial_success
op_time_us
​integer · uint64 · required

The operation time in microseconds.

message
​string

An optional message providing additional information about the status.

​object

The response data for this request.

A list of errors which may have occurred during the request.